# pantheon-backup

A Docker container to create website backups at Pantheon and back them up to GCP buckets.

## Build

docker build . -t electriccoinco/pantheon-backup

## Usage

### Requirements

#### Environmental variables
The entrypoint script requires 2 environmental variables.

- `PANTHEON_MACHINE_TOKEN`  
  Secret generated by Panthen https://pantheon.io/docs/machine-tokens/
- `GCP_SERVICEACCOUNT_FILE`   
A file path, inside the container, that points to a [GCP service account](https://developers.google.com/identity/protocols/oauth2/service-account) file with write access to `gs://website-backups-pantheon`

#### Mounts
- Mount a volume that maps a [GCP service account](https://developers.google.com/identity/protocols/oauth2/service-account) file to the path provided by `GCP_SERVICEACCOUNT_FILE`

### Example

```
docker run --rm \
  -e PANTHEON_MACHINE_TOKEN=MYSECRETTOKEN \
  -e GCP_SERVICEACCOUNT_FILE=/tmp/service.json \
  -v ./zcash-web-4c4432846cf1.json:/tmp/service.json \
  electriccoinco/pantheon-backup:latest
```

### Troubleshooting

Skip the entrypoint script and start a bash shell inside the container.

```
docker run --rm -ti --entrypoint bash electriccoinco/pantheon-backup:latest
```